// Funkce konstruktor: vytv objekt cookie pro specifikovan 
// dokument, se specifikovanm nzvem a volitelnmi atributy.
// Argumenty:
//     document: objekt Document, pro kter je cookie uchovna. Povinn.
//     name: etzec, kter specifikuje nzev pro cookie. Povinn.   
//     hours: voliteln slo, kter specifikuje poet hodin od nynjka, kdy
//              by platnost cookie mla vypret.
//     path: voliteln etzec, kter specifikuje atribut cesty cookie.
//     domain: voliteln etzec, kter specifikuje atribut domny cookie.
//     secure: voliteln logick hodnota, kter, pokud je true, vyaduje zabezpeen cookie.
//
function cookie(document, name, hours, path, domain, secure)
{
       // Vechny peddefinovan vlastnosti tohoto objektu zanaj znakem $,
       // aby se odliily od ostatnch vlastnost, je jsou hodnotami,
       // kter maj bt uloeny v cookie.
       this.$document = document;
       this.$name = name;
       if (hours)
                 this.$expiration = new Date((new Date()).getTime() + hours*3600000);  
       else this.$expiration = null;
       if (path) this.$path = path; else this.$path = null;
       if (domain) this.$domain = domain; else this.$domain = null;
       if (secure) this.$secure = true; else this.$secure = false;
}
// Tato funkce je metoda store() objektu cookie.
function _cookie_store()
{
       // Zaprv,cyklujte pes vlastnosti objektu cookie
       // a dejte dohromady hodnotu cookie. Protoe cookies
       // pouvaj znamnka rovn se a stednky jako separtory, my
       // pro jednotliv stavov promnn, kter ukldme v rmci
       // jedn hodnoty cookie, pouijeme dvojteky a znaky &.
       // Vimnte si, e na hodnotu kad stavov
       // promnn, v ppad, e obsahuje interpunkci nebo
       // jin nepovolen znaky, pouijeme funkci escape.
       var cookieval = "";
       for(var prop in this) {
                 // Ignorujte vlastnosti s nzvy, kter zanaj znakem $, a tak metody.
                 if ((prop.charAt(0) == '$') || ((typeof this[prop]) == 'function'))
                           continue;
                 if (cookieval != "") cookieval += '&';
                 cookieval += prop + ':' + escape(this[prop]);
       }
       // Nyn, kdy mme hodnotu cookie, dejme dohromady
       // kompletn etzec cookie, kter zahrnuje nzev a rzn
       // atributy, kter byly specifikovny, kdy byl vytvoen objekt cookie.
       var cookie = this.$name + '=' + cookieval;
       if (this.$expiration)
                 cookie += '; expires=' + this.$expiration.toGMTString();
       if (this.$path) cookie += '; path=' + this.$path;
       if (this.$domain) cookie += '; domain=' + this.$domain;
       if (this.$secure) cookie += '; secure';
       //Nyn cookie ulome nastavenm magick vlastnosti Document.cookie.   
       this.$document.cookie = cookie;
}
// Tato funkce je metoda load() objektu cookie.
function _cookie_load()
{
       // Zaprv obstarme seznam vech cookies, krer nle k tomuto dokumentu.
       // Udlme to tak, e peteme magickou vlastnost Document.cookie.
       var allcookies = this.$document.cookie;
       if (allcookies == "") return false;
       // Nyn z tohoto seznamu extrahujeme pouze pojmenovanou cookie.
       var start = allcookies.indexOf(this.$name + '=');
       if (start == -1) return false;          // cookie pro tuto strnku nen definivna
       start += this.$name.length + 1;         // peskome nzev a znamnko rovn se
       var end = allcookies.indexOf(';', start);
       if (end == -1) end = allcookies.length;
       var cookieval = allcookies.substring(start, end);
       // Nyn, kdy jsme extrahovali hodnotu pojmenovan cookie, musme
       // tuto hodnotu rozdlit na nzvy a hodnoty individulnch stavovch
       // promnnch. Pry name/value (nzev/hodnota) jsou jeden od druhho
       // oddleny znakami & a individuln nzvy a hodnoty jsou vzjemn oddleny
       // dvojtekami. K separaci pouvme metodu split.
       var a = cookieval.split('&');           // rozdlen na pole pru nzev/hodnota
       for(var i=0; i < a.length; i++)         // rozdlen kadho pru na pole
                 a[i] = a [i].split(':'); 

       // Nyn jsme separovali hodnotu cookie, nastavili vechny nzvy a hodnoty
       // stavovch promnnch v tomto objektu cookie. Vimnte si, e jsme provedli 
       // unescape() hodnoty vlastnosti, protoe jsme volali ecsape() kdy jsme ji ukldali.,
       for(var i = 0; i < a.length; i++) {
                 this[a[i][0]] = unescape(a[i][1]);
       }
       // Jsme hotovi, take vrtme spn kd.
       return true;
}
// Tato funkce je metoda remove() objektu cookie.
function _cookie_remove()
{
       var cookie;
       cookie = this.$name + '=';
       if (this.$path) cookie += '; path=' + this.$path;
       if (this.$domain) cookie += '; domain=' + this.$domain;
       cookie += '; expires=Fri, 02-Jan-1970 00:00:00 GMT';
       this.$document.cookie = cookie;
}
// Vytvo formln objekt cookie, abychom mohli pout prototypov objekt k zalenn 
// ve uvedench funkc do metod.
new cookie();
cookie.prototype.store = _cookie_store;
cookie.prototype.load = _cookie_load;
cookie.prototype.remove = _cookie_remove;
//=========================================================================================
// Ve uveden kd je definic tdy cookie.
